#!/usr/bin/haserl
<? # source the login lib and parse any input

. /var/www-db/loginlib.sh

userid=$( echo "$FORM_username" | sed "s/[^a-zA-Z0-9]//g" )
passwd=$( echo "$FORM_password" | sed "s/[^a-zA-Z0-9_+ !@#\$%\^\&\*]//g" )
sessid=$( echo "$FORM_sessid" | sed "s/[^a-zA-Z0-9_-]//g" )
CMD=$( echo "$FORM_CMD" | sed 's/[^a-zA-Z]//g' )
referer=$( echo "$FORM_referer" | sed 's/[^a-zA-Z0-9_\/:%\?#\&\.]//g' )
# [ -z "$referer" ] && referer=$HTTP_REFERER
?><?if [ "$CMD" = "Login" ] ?><? 
#---------------------------------------------------------------------
# Handle Login early - we forward to the referrer on successful login
#---------------------------------------------------------------------
usr=$( checkuserid $userid )
pswd=$( checkpasswd $userid $passwd )
dusr=$( checkdisabled $userid )
dip=$( checkdisabled "$REMOTE_ADDR" )
error=""


if [ -n "$dip" ] || [ -n "$dusr" ]; then
	if [ -n "$dip" ]; then
		error=$REMOTE_ADDR
		INFO_MSG="${INFO_MSG}$error is locked because of invalid login attempts<br>"
		fi

	if [ -z "$error" ] && [ -z "$usr" ]; then	
		error=$REMOTE_ADDR
		fi
		
	if [ -z "$error" ] && [ -n "$dusr" ]; then
		error="$userid"
		INFO_MSG="${INFO_MSG}$error is locked because of invalid login attempts<br>"
		fi
	else	# at least they are not disabled....
		# Valid user or password ?
	if [ -z "$usr" ] || [ -z "$pswd" ]; then
		if [ -z "$usr" ]; then 
			error="$REMOTE_ADDR"
			else
			error="$userid"
			fi
		fi
	fi

# if no errors, assign them a session
	if [ -z "$error" ]; then
		if [ -n "$( deletesession $userid )" ]; then
			INFO_MSG="${INFO_MSG}Deleted an existing session for $userid<br>";
			fi
		validsession=$( addsession $userid )
	else
	 	INFO_MSG="${INFO_MSG}Error detected.  Generating an invalid login attempt for $error.<br>"
 		addinvalidlogin $error
		# If its a real user, disable the IP address too - that
		# is, if I guess valid userids, but wrong passwords, eventually just lock the ip
		if [ "$error" != "$REMOTE_ADDR" ]; then
			addinvalidlogin $REMOTE_ADDR
	 		INFO_MSG="${INFO_MSG} Also generating an invalid login attempt for $REMOTE_ADDR.<br>"
			
			fi
		expiry=$( checkdisabled $error )
		[ -n "$expiry" ] && \
		INFO_MSG="${INFO_MSG}$error is locked for $( haserldb $expiry now \- 60 /) more minutes.<br>"
	 	if [ -n "$( deletesession "$error" )" ]; then
	 		INFO_MSG="${INFO_MSG}Deleted existing session for $error.<br>"
		 	validsession=""
		 	fi
 		fi

# And at this point, we either have a valid session, or not
?><?if [ -n "$validsession" ]?><?
	echo "Set-Cookie: sessid=$validsession; path=/;"
	[ -n "$referer" ] && echo "Refresh: 0; url=$referer"
	echo "Content-type: text/html"
	echo ""
	echo "<html><body><center>Login Sucessful</center></body></html>" 
	# Since we have a successful login, we expire old sessions
	expiresessions >/dev/null 2>/dev/null
	?>
	<?ab?><?fi #End Valid Session
	?><?fi #End Login
?><?if [ "$CMD" = "Logout" ] && [ -n "$sessid" ] ?><?
	echo "Set-Cookie: sessid=; path=/;"
	echo "Refresh: 0; url=$SCRIPT_NAME?CMD=Logout"
	echo "Content-type: text/html"
	echo ""
	echo "<html><body><center>Logout Sucessful</center></body></html>" 
	?><?ab?><?fi?>Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Sample Login Page</title>
<STYLE type="text/css">
        body  { color: black; background-color: white; font-family: arial; }
        b.red { color: #cc0000; font-size:200%; }
        b.sm-red { color: #cc0000; }
        b.green { color: #009900; font-size:200%; }
        td.yellow { background-color: #ffff00; }
</STYLE>
</head>
<body>

<?if [ "$CMD" = "Logout" ] ?>
<hr>
<center>
<p><b class=green>Logout Successful</b></p>
<hr>
<p>Click <a href="/index.cgi">here</a> to restart the application.</p></center>
<?ab?>
<?fi?>

<p> 
<form action="<? echo -n $SCRIPT_NAME ?>" method=post>
	<center>
	<hr />
	<b class=red>Please log in</b>
	<hr />
	<?if [ -n "$INFO_MSG" ] ?><b class=sm-red>We're sorry, but there was a problem with
	 your login information.  Please try again.</b><?fi?>
	<table border=0>
	<tr><td align=right>Username:</td>
		<td><input type=text size=14 name=username autocomplete=off></td></tr>
	<tr><td align=right>Passphrase:</td>
		<td><input type=password size=14 name=password autocomplete=off></td></tr>
	</table>
	<input type=hidden name=referer value="<? echo -n "$referer" ?>">
	<input type=submit name=CMD value="Login"><br>
	
	
	<?if [ -n "$INFO_MSG" ] ?>
	<hr>
	<table width=70%><tr><td>
	The following should not be shown on a real login page.  The reason for the failure:
	</td></tr>
	<td class=yellow><? echo "$INFO_MSG" ?></td></tr></table>
	<hr>
	<?fi?>
	</center></form>
</html>
